{{- define "library.ingress" -}}
{{- $nginxClass := "nginx"}}
{{- if ((.Values.ingress).enabled) -}}
{{- if semverCompare ">=1.19-0" .Capabilities.KubeVersion.GitVersion -}}
apiVersion: networking.k8s.io/v1
{{- else if semverCompare ">=1.14-0" .Capabilities.KubeVersion.GitVersion -}}
apiVersion: networking.k8s.io/v1beta1
{{- else -}}
apiVersion: extensions/v1beta1
{{- end }}
kind: Ingress
metadata:
  name: {{ .Chart.Name }}
  labels:
    {{- include "library.labels" . | nindent 4 }}
spec:
  {{- if and $nginxClass (semverCompare ">=1.18-0" .Capabilities.KubeVersion.GitVersion) }}
  ingressClassName: {{ $nginxClass }}
  {{- end }}
  tls:
    - hosts:
      - {{ tpl .Values.ingress.host . }}
      {{- if ((.Values.ingress).secretName) }}
      secretName: {{ ((.Values.ingress).secretName) }}
      {{ end }}
  rules:
    - host: {{ tpl .Values.ingress.host . }}
      http:
        paths:
          - path: {{ ((.Values.ingress).pathPrefix) | default "/" }}
            {{- if  semverCompare ">=1.18-0" $.Capabilities.KubeVersion.GitVersion }}
            pathType: "Prefix"
            {{- end }}
            backend:
              {{- if semverCompare ">=1.19-0" $.Capabilities.KubeVersion.GitVersion }}
              service:
                name: {{ .Chart.Name }}
                port:
                  number: {{ ((.Values.service).port) | default 80 }}
              {{- else }}
              serviceName: {{ .Chart.Name }}
              servicePort: {{ ((.Values.service).port) | default 80 }}
              {{- end }}
    {{- end }}
{{- end -}}